// ConvAsciiDlg.cpp : implementation file
//

#include  <afxwin.h>
#include  <afxcmn.h>
#include  <afxdlgs.h>

#include  "Pack.h"
#include  "Picture.h"
#include  "Conversion.h"
#include  "ConvAscii.h"
#include  "ConvAsciiDlg.h"
#include  "ChoixCouleur.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// CConvAsciiDlg dialog

CConvAsciiDlg::CConvAsciiDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CConvAsciiDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CConvAsciiDlg)
	//}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    DansSel = FALSE;
    memset( ImgAscii, 0, sizeof( ImgAscii ) );
    Pal[ 0 ] = 1;
    Pal[ 1 ] = 24;
    Pal[ 2 ] = 20;
    Pal[ 3 ] = 6;
}


void CConvAsciiDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CConvAsciiDlg)
    DDX_Control(pDX, IDC_COL03, m_Col03);
    DDX_Control(pDX, IDC_COL02, m_Col02);
    DDX_Control(pDX, IDC_COL01, m_Col01);
    DDX_Control(pDX, IDC_COL00, m_Col00);
    DDX_Control(pDX, IDC_FRAME, m_Frame);
    DDX_Control(pDX, IDC_LOSS, m_Perte);
    DDX_Control(pDX, IDC_105K, m_105k);
    DDX_Control(pDX, IDC_FRAME_N, m_FrameN);
    DDX_Control(pDX, IDC_ARRETAUTO, m_BpArretAuto);
    DDX_Control(pDX, IDC_BPREPLAY, m_BpReplay);
    DDX_Control(pDX, IDC_LIST, m_Liste);
    DDX_Control(pDX, IDC_AFFIMG, m_AffImg);
    DDX_Control(pDX, IDC_BPDEMARRE, m_BpDemarre);
    DDX_Control(pDX, IDC_BPARRETE, m_BpArret);
    DDX_Control(pDX, IDC_SOURCE, m_Source);
    DDX_Control(pDX, IDC_DEST, m_Dest);
    DDX_Control(pDX, IDC_ENDIMG, m_EndImg);
    DDX_Control(pDX, IDC_STARTIMG, m_StartImg);
    DDX_Control(pDX, IDC_SLIDETRAME, m_SlideTrame);
    DDX_Control(pDX, IDC_PCTTRAM, m_PctTrame);
    DDX_Control(pDX, IDC_MATRICE3, m_Matrice3);
    DDX_Control(pDX, IDC_MATRICE2, m_Matrice2);
    DDX_Control(pDX, IDC_TRAMEOFF, m_TrameOff);
    DDX_Control(pDX, IDC_TRAME3, m_Trame3);
    DDX_Control(pDX, IDC_TRAME2, m_Trame2);
    DDX_Control(pDX, IDC_TRAME1, m_Trame1);
    DDX_Control(pDX, IDC_SLIDESEUIL, m_SlideSeuil);
    DDX_Control(pDX, IDC_SEUL, m_Seuil);
    DDX_Control(pDX, IDC_SIZE_SUP, m_SizeSup);
    DDX_Control(pDX, IDC_SIZE_ORG, m_SizeOrg);
    DDX_Control(pDX, IDC_SIZE_INF, m_SizeInf);
    DDX_Control(pDX, IDC_SIZE_CPC, m_SizeCPC);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConvAsciiDlg, CDialog)
    //{{AFX_MSG_MAP(CConvAsciiDlg)
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_EN_CHANGE(IDC_SEUL, OnChangeSeul)
    ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDESEUIL, OnReleasedcaptureSlideseuil)
    ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_SLIDETRAME, OnReleasedcaptureSlidetrame)
    ON_EN_CHANGE(IDC_PCTTRAM, OnChangePcttram)
    ON_BN_CLICKED(IDC_TRAMEOFF, OnTrameoff)
    ON_BN_CLICKED(IDC_TRAME3, OnTrame3)
    ON_BN_CLICKED(IDC_TRAME2, OnTrame2)
    ON_BN_CLICKED(IDC_TRAME1, OnTrame1)
    ON_BN_CLICKED(IDC_SIZE_CPC, OnSizeCpc)
    ON_BN_CLICKED(IDC_SIZE_INF, OnSizeInf)
    ON_BN_CLICKED(IDC_SIZE_ORG, OnSizeOrg)
    ON_BN_CLICKED(IDC_SIZE_SUP, OnSizeSup)
    ON_BN_CLICKED(IDC_MATRICE2, OnMatrice2)
    ON_BN_CLICKED(IDC_MATRICE3, OnMatrice3)
    ON_BN_CLICKED(IDC_BPSOURCE, OnBpsource)
    ON_BN_CLICKED(IDC_BPDEST, OnBpdest)
    ON_BN_CLICKED(IDC_BPDEMARRE, OnBpdemarre)
    ON_BN_CLICKED(IDC_BPARRETE, OnBparrete)
    ON_BN_CLICKED(IDC_AFFIMG, OnAffimg)
    ON_BN_CLICKED(IDC_BPREPLAY, OnReplay)
    ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_COL00, OnCol00)
	ON_BN_CLICKED(IDC_COL01, OnCol01)
	ON_BN_CLICKED(IDC_COL02, OnCol02)
	ON_BN_CLICKED(IDC_COL03, OnCol03)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CConvAsciiDlg message handlers


BOOL CConvAsciiDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);            // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    CopieDC = GetDC();
    if ( CreeBitmap( &DcBitmap
                   , &bm
                   , ( void ** )&MemBitmap
                   , CopieDC->m_hDC
                   , TAILLE_X
                   , TAILLE_Y
                   )
       )
        {
        m_SlideSeuil.SetRange( 0, 255 );
        m_SlideSeuil.SetPageSize( 8 );
        m_SlideTrame.SetRange( 0, 100 );
        m_SlideTrame.SetPageSize( 5 );
        m_Seuil.SetWindowText( "128" );
        Seuil = 128;
        m_PctTrame.SetWindowText( "50" );
        Pct = 50;
        m_TrameOff.SetCheck( 1 );
        OnTrameoff();
        m_Matrice2.SetCheck( 1 );
        OnMatrice2();
        m_SizeCPC.SetCheck( 1 );
        OnSizeCpc();
        m_StartImg.SetWindowText( "1" );
        m_EndImg.SetWindowText( "10000" );
        m_BpArret.EnableWindow( FALSE );
        m_BpDemarre.EnableWindow( TRUE );
        m_AffImg.SetCheck( 1 );
        OnAffimg();
        m_BpArretAuto.SetCheck( 1 );
        }

    return TRUE;  // return TRUE  unless you set the focus to a control
}


void CConvAsciiDlg::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    if (IsIconic())
        {
        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;
        dc.DrawIcon(x, y, m_hIcon);
        }
    else
        {
        DrawImage();
        CRect rect;
        CDC * d;
        d = m_Col00.GetDC();
        m_Col00.GetClientRect( rect );
        d->FillSolidRect( rect, GetRgbCPC( Pal[ 0 ] ) );
        ReleaseDC( d );
        d = m_Col01.GetDC();
        m_Col01.GetClientRect( rect );
        d->FillSolidRect( rect, GetRgbCPC( Pal[ 1 ] ) );
        ReleaseDC( d );
        d = m_Col02.GetDC();
        m_Col02.GetClientRect( rect );
        d->FillSolidRect( rect, GetRgbCPC( Pal[ 2 ] ) );
        ReleaseDC( d );
        d = m_Col03.GetDC();
        m_Col03.GetClientRect( rect );
        d->FillSolidRect( rect, GetRgbCPC( Pal[ 3 ] ) );
        ReleaseDC( d );
        }
}


HCURSOR CConvAsciiDlg::OnQueryDragIcon()
{
    return( ( HCURSOR )m_hIcon );
}


void CConvAsciiDlg::DrawImage( void )
{
    int xmat, ymat, Pos = 0;

    for ( int y = 25; y--; )
        for ( int x = 0; x < 80; x++ )
            {
            int CodeAscii = ImgAscii[ Pos++ ];
            int o1 = CodeAscii & 3;
            int o2 = ( CodeAscii >> 2 ) & 3;
            int o3 = ( CodeAscii >> 4 ) & 3;
            int o4 = ( CodeAscii >> 6 ) & 3;
            for ( xmat = 0; xmat < 4; xmat++ )
                for ( ymat = 0; ymat < 4; ymat++ )
                    MemBitmap[ ( xmat + ( x << 3 ) ) + TAILLE_X * ( 7 - ymat + ( y << 3 ) ) ] = Tab4C[ o1 ];

            for ( xmat = 4; xmat < 8; xmat++ )
                for ( ymat = 0; ymat < 4; ymat++ )
                    MemBitmap[ ( xmat + ( x << 3 ) ) + TAILLE_X * ( 7 - ymat + ( y << 3 ) ) ] = Tab4C[ o2 ];

            for ( xmat = 0; xmat < 4; xmat++ )
                for ( ymat = 4; ymat < 8; ymat++ )
                    MemBitmap[ ( xmat + ( x << 3 ) ) + TAILLE_X * ( 7 - ymat + ( y << 3 ) ) ] = Tab4C[ o3 ];

            for ( xmat = 4; xmat < 8; xmat++ )
                for ( ymat = 4; ymat < 8; ymat++ )
                    MemBitmap[ ( xmat + ( x << 3 ) ) + TAILLE_X * ( 7 - ymat + ( y << 3 ) ) ] = Tab4C[ o4 ];

            }

    CDC * dc = GetDC();
    StretchBlt( dc->m_hDC, 4, 10, TAILLE_X, TAILLE_Y << 1
              , DcBitmap, 0, 0, TAILLE_X, TAILLE_Y
              , SRCCOPY
              );
    ReleaseDC( dc );
}


void CConvAsciiDlg::InitBitmap( void )
{
    int x = 0, y = 0;
    int tx = TAILLE_X, ty = TAILLE_Y;
    SIZE s = Picture.GetImageSize();
    if ( s.cx && s.cy )
        {
        //
        // Garder taille d'origine ?
        //
        if ( TailleOrg )
            {
            ty = s.cy >> 2;
            tx = s.cx >> 1;
            x = ( TAILLE_X - tx ) >> 1;
            y = ( TAILLE_Y - ty ) >> 1;
            }
        //
        // Garder chelle avec proportions infrieure ?
        //
        if ( PropInf )
            {
            double RatioImg = s.cx / ( double )s.cy;
            if ( RatioImg < RATIO_ECRAN )
                {
                tx = ( int )( TAILLE_X * RatioImg / RATIO_ECRAN );
                ty = TAILLE_Y;
                x = ( TAILLE_X - tx ) / 2;
                y = 0;
                }
            else
                {
                tx = TAILLE_X;
                ty = ( int )( TAILLE_Y * RATIO_ECRAN / RatioImg );
                x = 0;
                y = ( TAILLE_Y - ty ) / 2;
                }
            }
        else
            //
            // Garder chelle avec proportions suprieure ?
            //
            if ( PropSup )
                {
                double RatioImg = s.cx / ( double )s.cy;
                if ( RatioImg < RATIO_ECRAN  )
                    {
                    tx = TAILLE_X;
                    ty = ( int )( TAILLE_Y * RATIO_ECRAN / RatioImg );
                    x = 0;
                    y = ( TAILLE_Y - ty ) / 2;
                    }
                else
                    {
                    tx = ( int )( TAILLE_X * RatioImg / RATIO_ECRAN );
                    ty = TAILLE_Y;
                    x = ( TAILLE_X - tx ) / 2;
                    y = 0;
                    }
                }
        //
        // Effacer le bitmap
        //
        memset( MemBitmap, 0, TAILLE_X * TAILLE_Y * 4 );
        RECT r;
        r.bottom = y;
        r.left = x;
        r.top = y + ty;
        r.right = x + tx;
        //
        // Dessiner l'image
        //
        Picture.Render( DcBitmap, &r );
        }
}


void CConvAsciiDlg::GetChaineInfoImage( int NumImage
                                      , char TypeImage
                                      , int SizeImage
                                      , int TailleTot
                                      )
{
    int Pct = m_105k.GetCheck() ? 100 * TailleTot / ( TAILLE_BANQUES * 4 + TAILLE_BANQUE0 )
                                : 100 * TailleTot / ( TAILLE_BANQUES * 6 );
    sprintf( Tmp
           , "Image %d : %c %4d (%d - %d%%)"
           , NumImage
           , TypeImage
           , SizeImage
           , TailleTot
           , Pct
           );
    m_Liste.AddString( Tmp );
    m_Liste.SetCurSel( m_Liste.GetCount() - 1 );
    m_Liste.UpdateWindow();
    switch( TypeImage )
        {
        case 'O' :
            NbImagesO++;
            break;

        case 'D' :
            NbImagesD++;
            break;

        case 'I' :
            NbImagesI++;
            break;

        case 'N' :
            NbImagesN++;
            break;
        }
}


void CConvAsciiDlg::BoucleConvert( void )
{
    static BYTE BufTmp[ 0x1000 ];
    static BYTE BufCmp[ 0x1000 ];
    static BYTE BufCmp2[ 0x1000 ];
    char Nom[ 256 ];
    MSG msg;

    DemandeFin = FALSE;
    m_BpArret.EnableWindow( TRUE );
    m_BpDemarre.EnableWindow( FALSE );
    m_BpReplay.EnableWindow( FALSE );
    int lTot = 0;
    InitBank();

    memset( OldImgAscii, 0, sizeof( OldImgAscii ) );
    memset( ImgAscii, 0, sizeof( ImgAscii ) );
    m_StartImg.GetWindowText( Nom, sizeof( Nom ) );
    int depart = atoi( Nom );
    m_EndImg.GetWindowText( Nom, sizeof( Nom ) );
    int fin = atoi( Nom );
    m_Liste.ResetContent();
    m_Source.GetWindowText( NomSource, sizeof( NomSource ) );
    m_Dest.GetWindowText( NomDest, sizeof( NomDest ) );
    int NbImages = NbImagesI = NbImagesN = NbImagesD = NbImagesO = 0;
    for ( int i = depart; i <= fin; i++ )
        {
        sprintf( Nom, NomSource, i );
        if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
            DispatchMessage( &msg );

        if ( DemandeFin )
            break;

        if ( Picture.Load( Nom ) )
            {
            sprintf( Tmp, "Image %d", ++NbImages );
            m_Frame.SetWindowText( Tmp );
            //
            // Dessine l'image dans le bitmap
            //
            InitBitmap();
            Convert( MemBitmap
                   , ImgAscii
                   , Methode
                   , Pct
                   , Matrice
                   , Seuil
                   );

            if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                DispatchMessage( &msg );

            if ( m_AffImg.GetCheck() )
                DrawImage();

            unsigned short lSave = sizeof( ImgAscii );
            //
            // Calcule les diffrences inter images
            //
            unsigned short l = GenereDiff( ImgAscii
                                         , OldImgAscii
                                         , DiffAscii
                                         , NegAscii
                                         , m_Perte.GetCheck()
                                         , m_FrameN.GetCheck()
                                         );
            if ( l < ( lSave / 1.2 ) )
                lSave = l;

            if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                DispatchMessage( &msg );

            unsigned short lNeg = 0xFFF;
            if ( m_FrameN.GetCheck() )
                {
                int n = NegAscii[ 3 ] + 256 * NegAscii[ 4 ];
                if ( n > 0 && n < 2000 )
                    lNeg = ( unsigned short )PackBuffer( NegAscii, n + 5, BufCmp2 );
                else
                    lNeg = 0xFFF;
                }

            if ( lSave == sizeof( ImgAscii ) )
                {
                //
                // Image complte
                //
                BufTmp[ 0 ] = 'O';
                memcpy( &BufTmp[ 1 ], ImgAscii, lSave );
                lSave = ( unsigned short )PackBuffer( BufTmp, lSave + 1, BufCmp );
                if ( lNeg < lSave )
                    {
                    lSave = lNeg;
                    memcpy( BufCmp, BufCmp2, lSave );
                    BufTmp[ 0 ] = 'N';
                    }
                }
            else
                if ( lSave )
                    {
                    //
                    // Image "Delta"
                    //
                    BufTmp[ 0 ] = 'D';
                    memcpy( &BufTmp[ 1 ], &lSave, sizeof( lSave ) );
                    memcpy( &BufTmp[ 3 ], DiffAscii, lSave );
                    lSave = ( unsigned short )PackBuffer( BufTmp, lSave + 3, BufCmp );
                    if ( lNeg < lSave )
                        {
                        lSave = lNeg;
                        memcpy( BufCmp, BufCmp2, lSave );
                        BufTmp[ 0 ] = 'N';
                        }
                    }
                else
                    {
                    //
                    // Image Identique
                    //
                    BufTmp[ 0 ] = 'I';
                    lSave = ( unsigned short )PackBuffer( BufTmp, 1, BufCmp );
                    }
            AjouteBank( BufCmp, lSave, NomDest, &m_Liste, m_105k.GetCheck() );
            lTot += lSave;
            GetChaineInfoImage( i, BufTmp[ 0 ], lSave, lTot );
            if ( m_BpArretAuto.GetCheck() && GetNumBank() > ( m_105k.GetCheck() ? 4 : 5 ) )
                DemandeFin = TRUE;

            if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                DispatchMessage( &msg );
            //
            // Ancienne image = nouvelle image
            //
            if ( lSave )
                memcpy( OldImgAscii, ImgAscii, sizeof( ImgAscii ) );
            }
        }
    //
    // Affichage rsum
    //
    sprintf( Tmp, "Nombre d'images converties : %d", NbImages );
    m_Liste.AddString( Tmp );
    if ( NbImages )
        {
        sprintf( Tmp, "Nombre d'images O : %d", NbImagesO );
        m_Liste.AddString( Tmp );
        sprintf( Tmp, "Nombre d'images D : %d", NbImagesD );
        m_Liste.AddString( Tmp );
        sprintf( Tmp, "Nombre d'images I : %d", NbImagesI );
        m_Liste.AddString( Tmp );
        sprintf( Tmp, "Nombre d'images N : %d", NbImagesN );
        m_Liste.AddString( Tmp );
        sprintf( Tmp, "Taille moyenne image : %d", lTot / NbImages );
        m_Liste.AddString( Tmp );
        }

    EndBank( NomDest, &m_Liste );
    m_BpArret.EnableWindow( FALSE );
    m_BpDemarre.EnableWindow( TRUE );
    m_BpReplay.EnableWindow( TRUE );
}


void CConvAsciiDlg::OnChangeSeul()
{
    if ( ! DansSel )
        {
        DansSel = TRUE;
        m_Seuil.GetWindowText( Tmp, sizeof( Tmp ) );
        Seuil = atoi( Tmp );
        if ( Seuil < 0 )
            {
            Seuil = 0;
            m_Seuil.SetWindowText( "0" );
            }
        else
            if ( Seuil > 255 )
                {
                Seuil = 255;
                m_Seuil.SetWindowText( "255" );
                }

        m_SlideSeuil.SetPos( Seuil );
        DansSel = FALSE;
        }
}


void CConvAsciiDlg::OnReleasedcaptureSlideseuil(NMHDR* pNMHDR, LRESULT* pResult) 
{
    if ( ! DansSel )
        {
        DansSel = TRUE;
        Seuil = m_SlideSeuil.GetPos();
        itoa( Seuil, Tmp, 10 );
        m_Seuil.SetWindowText( Tmp );
        DansSel = FALSE;
        }
    * pResult = 0;
}


void CConvAsciiDlg::OnChangePcttram() 
{
    if ( ! DansSel )
        {
        DansSel = TRUE;
        m_PctTrame.GetWindowText( Tmp, sizeof( Tmp ) );
        Pct = atoi( Tmp );
        if ( Pct < 0 )
            {
            Pct = 0;
            m_PctTrame.SetWindowText( "0" );
            }
        else
            if ( Pct > 100 )
                {
                Pct = 100;
                m_PctTrame.SetWindowText( "100" );
                }

        m_SlideTrame.SetPos( Pct );
        DansSel = FALSE;
        }
}


void CConvAsciiDlg::OnReleasedcaptureSlidetrame(NMHDR* pNMHDR, LRESULT* pResult) 
{
    if ( ! DansSel )
        {
        DansSel = TRUE;
        Pct = m_SlideTrame.GetPos();
        itoa( Pct, Tmp, 10 );
        m_PctTrame.SetWindowText( Tmp );
        DansSel = FALSE;
        }
    * pResult = 0;
}


void CConvAsciiDlg::OnTrameoff()
{
    Methode = 0;
    m_Matrice2.EnableWindow( FALSE );
    m_Matrice3.EnableWindow( FALSE );
    m_PctTrame.EnableWindow( FALSE );
    m_SlideTrame.EnableWindow( FALSE );
}


void CConvAsciiDlg::OnTrame3()
{
    Methode = 3;
    m_Matrice2.EnableWindow( TRUE );
    m_Matrice3.EnableWindow( TRUE );
    m_PctTrame.EnableWindow( TRUE );
    m_SlideTrame.EnableWindow( TRUE );
}


void CConvAsciiDlg::OnTrame2()
{
    Methode = 2;
    m_Matrice2.EnableWindow( TRUE );
    m_Matrice3.EnableWindow( TRUE );
    m_PctTrame.EnableWindow( TRUE );
    m_SlideTrame.EnableWindow( TRUE );
}


void CConvAsciiDlg::OnTrame1()
{
    Methode = 1;
    m_Matrice2.EnableWindow( TRUE );
    m_Matrice3.EnableWindow( TRUE );
    m_PctTrame.EnableWindow( TRUE );
    m_SlideTrame.EnableWindow( TRUE );
}


void CConvAsciiDlg::OnSizeCpc()
{
    TailleOrg = 0;
    PropInf = 0;
    PropSup = 0;
}


void CConvAsciiDlg::OnSizeInf()
{
    TailleOrg = 0;
    PropInf = 1;
    PropSup = 0;
}


void CConvAsciiDlg::OnSizeOrg()
{
    TailleOrg = 1;
    PropInf = 0;
    PropSup = 0;
}


void CConvAsciiDlg::OnSizeSup()
{
    TailleOrg = 0;
    PropInf = 0;
    PropSup = 1;
}


void CConvAsciiDlg::OnMatrice2()
{
    Matrice = 2;
}


void CConvAsciiDlg::OnMatrice3()
{
    Matrice = 3;
}


void CConvAsciiDlg::OnBpsource()
{
    m_Source.GetWindowText( NomSource, sizeof( NomSource ) );
    CFileDialog SelectFic( TRUE
                         , NULL
                         , NomSource
                         , OFN_FILEMUSTEXIST
                         , "Tous les fichiers (*.*)|*.*||"
                         );
    if ( SelectFic.DoModal() == IDOK )
        {
        m_Source.SetWindowText( SelectFic.GetPathName() );
        m_Source.GetWindowText( NomSource, sizeof( NomSource ) );
        // Recherche un nombre dans la chaine si il n'y a pas de %
        char * p = strchr( NomSource, '%' );
        if ( ! p )
            {
            p = &NomSource[ strlen( NomSource ) -1 ];
            while( p > NomSource && ! isdigit( * p ) )
                p--;

            if ( isdigit( * p ) )
                {
                char Fin[ 256 ];
                strcpy( Fin, &p[ 1 ] );
                while( p > NomSource && isdigit( * p ) )
                    p--;

                if ( p > NomSource )
                    {
                    * ++p = 0;
                    strcat( NomSource, "%d" );
                    strcat( NomSource, Fin );
                    m_Source.SetWindowText( NomSource );
                    }
                }
            }
        }
}


void CConvAsciiDlg::OnBpdest()
{
    m_Dest.GetWindowText( NomDest, sizeof( NomDest ) );
    CFileDialog SelectFic( FALSE
                         , NULL
                         , NomDest
                         , OFN_FILEMUSTEXIST
                         , "Tous les fichiers (*.*)|*.*||"
                         );
    if ( SelectFic.DoModal() == IDOK )
        {
        m_Dest.SetWindowText( SelectFic.GetPathName() );
        m_Dest.GetWindowText( NomDest, sizeof( NomDest ) );
        // Recherche dans la chaine un "." avant le premier "\"
        char * p = strchr( NomDest, '.' );
        if ( p )
            {
            p = &NomDest[ strlen( NomDest ) - 1 ];
            while( p > NomDest && * p != '.' )
                {
                if ( * p == '\\' )
                    break;

                p--;
                }
            if ( * p == '.' )
                {
                * p = 0;
                m_Dest.SetWindowText( NomDest );
                }
            }
        }
}


void CConvAsciiDlg::OnBpdemarre()
{
    BoucleConvert();
}


void CConvAsciiDlg::OnBparrete()
{
    DemandeFin = TRUE;
}


void CConvAsciiDlg::OnAffimg()
{
}


void CConvAsciiDlg::OnOK()
{
}


void CConvAsciiDlg::AfficheImageO( BYTE * Bank )
{
    memcpy( ImgAscii, &Bank[ 1 ], 2000 );
}


void CConvAsciiDlg::AfficheImageI( BYTE * Bank )
{
    int PosBank = 3;
    unsigned short lg = ( unsigned short )( Bank[ 1 ] + ( Bank[ 2 ] << 8 ) );
    int Pos = 0;
    while( lg )
        {
        int dist = Bank[ PosBank++ ];
        Pos += dist;
        ImgAscii[ Pos++ ] = Bank[ PosBank++ ];
        lg -= 2;
        }
}


void CConvAsciiDlg::AfficheImageN( BYTE * Bank )
{
    unsigned short Pos = ( unsigned short )( Bank[ 1 ] + ( Bank[ 2 ] << 8 ) );
    unsigned short lg = ( unsigned short )( Bank[ 3 ] + ( Bank[ 4 ] << 8 ) );
    int PosBank = 5;
    for ( ; lg--; )
        ImgAscii[ Pos++ ] ^= Bank[ PosBank++ ];
}


void CConvAsciiDlg::OnReplay( void )
{
    static BYTE Bank[ 0x10000 ];
    static BYTE Depack[ 0x800 ];
    char NomFic[ 256 ];
    int PosBank;
    unsigned long Time, OldTime = 0;
    MSG msg;

    DemandeFin = FALSE;
    m_BpArret.EnableWindow( TRUE );
    m_BpDemarre.EnableWindow( FALSE );
    m_BpReplay.EnableWindow( FALSE );
    m_Dest.GetWindowText( NomDest, sizeof( NomDest ) );
    memset( ImgAscii
          , 0
          , sizeof( ImgAscii )
          );
    int Frame = 0;
    for ( int i = 0; i < 200; i++ )
        {
        if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
            DispatchMessage( &msg );

        wsprintf( NomFic, "%s.bk%d", NomDest, i );
        FILE * fp = fopen( NomFic, "rb" );
        if ( fp )
            {
            memset( Bank, 0, sizeof( Bank ) );
            fread( Bank, sizeof( Bank ), 1, fp );
            fclose( fp );
            PosBank = 0;
            while( ! DemandeFin )
                {
                sprintf( Tmp, "Image %d", ++Frame );
                m_Frame.SetWindowText( Tmp );
                if ( Bank[ PosBank ] || Bank[ PosBank + 1 ] )
                    {
                    PosBank += DepackBuffer( &Bank[ PosBank ], Depack );
                    PosBank++;      // A cause du 0
                    if ( * Depack == 'O' )
                        AfficheImageO( Depack );
                    else
                        if ( * Depack == 'D' )
                            AfficheImageI( Depack );
                        else
                            if ( * Depack == 'N' )
                                AfficheImageN( Depack );
                            else
                                if ( * Depack == 'I' )
                                    ;
                                else
                                    break;
                    }
                else
                    break;

                DrawImage();
                do
                    {
                    Sleep( 1 );
                    if ( PeekMessage( &msg, NULL, 0,0, PM_REMOVE ) )
                        DispatchMessage( &msg );

                    Time = GetTickCount();
                    }
                while( Time - OldTime < 50 );
                OldTime = Time;
                }
            }
        }
    m_BpArret.EnableWindow( FALSE );
    m_BpDemarre.EnableWindow( TRUE );
    m_BpReplay.EnableWindow( TRUE );
}


void CConvAsciiDlg::OnClose()
{
    DemandeFin = TRUE;
    ReleaseDC( CopieDC );
    DeleteBitmapEcran( DcBitmap, bm );
    CDialog::OnClose();
}


void CConvAsciiDlg::ClickCol( int NumCol )
{
    CChoixCouleur c( Pal[ NumCol ], this );
    c.DoModal();
    if ( c.GetRetour() )
        {
        Pal[ NumCol ] = ( BYTE )c.GetCouleur();
        Tab4C[ NumCol ] = RgbCPC[ Pal[ NumCol ] ];
        InvalidateRect( NULL );
        }
}


void CConvAsciiDlg::OnCol00()
{
    ClickCol( 0 );
}


void CConvAsciiDlg::OnCol01()
{
    ClickCol( 1 );
}


void CConvAsciiDlg::OnCol02()
{
    ClickCol( 2 );
}


void CConvAsciiDlg::OnCol03()
{
    ClickCol( 3 );
}
