// ConvAsciiDlg.h : header file
//

#if !defined(AFX_CONVASCIIDLG_H__9B49581E_0E88_45BD_BD91_2F93FED85C6F__INCLUDED_)
#define AFX_CONVASCIIDLG_H__9B49581E_0E88_45BD_BD91_2F93FED85C6F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CConvAsciiDlg dialog

class CConvAsciiDlg : public CDialog
{
// Construction
public:
    CConvAsciiDlg(CWnd* pParent = NULL);    // standard constructor

// Dialog Data
    //{{AFX_DATA(CConvAsciiDlg)
	enum { IDD = IDD_CONVASCII_DIALOG };
	CStatic	m_Col03;
	CStatic	m_Col02;
	CStatic	m_Col01;
	CStatic	m_Col00;
	CStatic	m_Frame;
	CButton	m_Perte;
	CButton	m_105k;
	CButton	m_FrameN;
    CButton     m_BpArretAuto;
    CButton     m_BpReplay;
    CListBox    m_Liste;
    CButton     m_AffImg;
    CButton     m_BpDemarre;
    CButton     m_BpArret;
    CEdit       m_Source;
    CEdit       m_Dest;
    CEdit       m_EndImg;
    CEdit       m_StartImg;
    CSliderCtrl m_SlideTrame;
    CEdit       m_PctTrame;
    CButton     m_Matrice3;
    CButton     m_Matrice2;
    CButton     m_TrameOff;
    CButton     m_Trame3;
    CButton     m_Trame2;
    CButton     m_Trame1;
    CSliderCtrl m_SlideSeuil;
    CEdit       m_Seuil;
    CButton     m_SizeSup;
    CButton     m_SizeOrg;
    CButton     m_SizeInf;
    CButton     m_SizeCPC;
	//}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CConvAsciiDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    HICON m_hIcon;

    // Generated message map functions
    //{{AFX_MSG(CConvAsciiDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnPaint();
    afx_msg HCURSOR OnQueryDragIcon();
    afx_msg void OnChangeSeul();
    afx_msg void OnReleasedcaptureSlideseuil(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnReleasedcaptureSlidetrame(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnChangePcttram();
    afx_msg void OnTrameoff();
    afx_msg void OnTrame3();
    afx_msg void OnTrame2();
    afx_msg void OnTrame1();
    afx_msg void OnSizeCpc();
    afx_msg void OnSizeInf();
    afx_msg void OnSizeOrg();
    afx_msg void OnSizeSup();
    afx_msg void OnMatrice2();
    afx_msg void OnMatrice3();
    afx_msg void OnBpsource();
    afx_msg void OnBpdest();
    afx_msg void OnBpdemarre();
    afx_msg void OnBparrete();
    afx_msg void OnAffimg();
    afx_msg void OnOK();
    afx_msg void OnReplay();
    afx_msg void OnClose();
    afx_msg void OnArretauto();
	afx_msg void OnFrameN();
	afx_msg void OnCol00();
	afx_msg void OnCol01();
	afx_msg void OnCol02();
	afx_msg void OnCol03();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

private :
    void ClickCol( int NumCol );
    void InitBitmap( void );
    void DrawImage( void );
    void BoucleConvert( void );
    void AfficheImageO( BYTE * Bank );
    void AfficheImageI( BYTE * Bank );
    void AfficheImageN( BYTE * Bank );
    void GetChaineInfoImage( int NumImage
                           , char TypeImage
                           , int SizeImage
                           , int TailleTot
                           );

    CPicture Picture;
    HBITMAP bm;
    StRVB * MemBitmap;
    CDC * CopieDC;
    HDC DcBitmap;
    BYTE ImgAscii[ 0x800 ];
    BYTE OldImgAscii[ 0x800 ];
    BYTE DiffAscii[ 0x800 ];
    BYTE NegAscii[ 0x800 ];
    BOOL DrawWindow, DansSel, DemandeFin, ArretAuto;
    int TailleOrg, PropInf, PropSup;
    int Methode, Seuil, Pct, Matrice;
    int NbImagesI, NbImagesD, NbImagesO, NbImagesN;
    char NomSource[ 256 ];
    char NomDest[ 256 ];
    char Tmp[ 256 ];
    BYTE Pal[ 4 ];
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONVASCIIDLG_H__9B49581E_0E88_45BD_BD91_2F93FED85C6F__INCLUDED_)
